<?php
/**
 *
 * This software is distributed under the GNU LGPL v3.0 license.
 * Pirate's project
 * PostEngine
 * @author Vladyslav Karpenko <Pirate>
 * @copyright 2008-2010
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt
 * @link http://postengine.ru
 * @version 1.0
 */

/* Функция отфильтровки чисел */
function int($int)
{
	return abs(intval($int));
}

/* Функция защиты от нежелательных действий */
function protect($text)
{
	/* экспериментальное удаление null-байта */
	$text = str_replace("\0", '', $text);
	return trim(mysql_real_escape_string(htmlspecialchars($text, ENT_QUOTES, 'utf-8')));
}

/* Функции подсветки PHP кода */
function highlight_code($code)
{
	$code = stripslashes($code);
   	if(!strpos($code,"<?") and substr($code,0,2)!="<?")
  	{
    	$code="<?php\n".trim($code)."\n?>";
  	}
  	$code = trim($code);
  	$code = strtr($code,array('&#124;'=>'|','&lt;'=>'<','&gt;'=>'>','&amp;'=>'&','&#36;'=>'$','&quot;'=>'"','&#39;'=>"'",'&#92;'=>'`','&#37;'=>'%','&#94;'=>'^','&#58;'=>':','<br />'=>"\r\n"));
  	$code = strtr($code,array("\r\n"=>'<br />','|'=>'&#124;','$'=>'&#36;',"'"=>'&#39;','`'=>'&#92;','%'=>'&#37;','^'=>'&#94;',':'=>'&#58;'));
  	return highlight_string($code,true);
}

function code($code)
{
	return preg_replace(array('#\[([code|php]+)\](.*?)\[\/([code|php]+)\]#se'), array(highlight_code('\\2')), $code);
}

/* Функция BB кода */
function BBcode($text)
{
	$bbcode = array(
		'/\[url\](.+)\[\/url\]/isU'                                       =>'<a href="$1">$1</a>',
		'/\[url=(.+)\](.+)\[\/url\]/isU'                                  =>'<a href="$1">$2</a>',
		'/\[img=(.+)\]/isU'                                               =>'<img src="$1">',
		'/\[br]/isU' 											          =>'<br />',
		'/\[i\](.+)\[\/i\]/isU'                                           =>'<i>$1</i>',
 		'/\[b\](.+)\[\/b\]/isU'                                           =>'<strong>$1</strong>',
		'/\[del\](.+)\[\/del\]/isU'                                       =>'<span style="text-decoration: line-through">$1</span>',
		'/\[u\](.+)\[\/u\]/isU'                                           =>'<span style="text-decoration:underline">$1</span>',
		'/\[big\](.+)\[\/big\]/isU'                                       =>'<big>$1</big>',
		'/\[small\](.+)\[\/small\]/isU'                                   =>'<small>$1</small>',
		'/\[color=(.+)\](.+)\[\/color\]/isU'                              =>'<span style="color:#$1">$2</span>',
		'/\[red\](.+)\[\/red\]/isU'                                       =>'<span style="color:#ff0000">$1</span>',
		'/\[yellow\](.+)\[\/yellow\]/isU'                                 =>'<span style="color:#ffff22">$1</span>',
		'/\[green\](.+)\[\/green\]/isU'                                   =>'<span style="color:#00bb00">$1</span>',
		'/\[blue\](.+)\[\/blue\]/isU'                                     =>'<span style="color:#0000bb">$1</span>');
 	return preg_replace(array_keys($bbcode),array_values($bbcode),$text);
}

function HTML2BBcode($text)
{
   	$bbcode = array(
      	'/<a href="(.+)">(.+)<\/a>/isU'                                   => '[url]$1[/url]',
      	'/<a href="(.+)">(.+)<\/a>/isU'                                   => '[url=$1]$2[/url]',
      	'/<img src="(.+)">/isU'                                           => '[img=$1]',
      	'/<br \/>/isU'                                                    => '[br]',
      	'/<i>(.+)<\/i>/isU'                                               => '[i]$1[/i]',
      	'/<strong\>(.+)<\/strong>/isU'                                    => '[b]$1[/b]',
      	'/<span style="text-decoration: line-through">(.+)<\/span>/isU'   => '[del]$1[/del]',
      	'/<span style="text-decoration:underline">(.+)<\/span>/isU'       => '[u]$1[/u]',
      	'/<big>(.+)<\/big>/isU'                                           => '[big]$1[/big]',
      	'/<small>(.+)<\/small>/isU'                                       => '[small]$1[/small]',
      	'/<span style="color:#(.+)">(.+)<\/span>/isU'                     => '[color=$1]$2[/color]',
      	'/<span style="color:#ff0000">(.+)<\/span>/isU'                   => '[red]$1[/red\]',
      	'/<span style="color:#ffff22">(.+)<\/span>/isU'                   => '[yellow]$1[/red\]',
      	'/<span style="color:#00bb00">(.+)<\/span>/isU'                   => '[green]$1[/red\]',
      	'/<span style="color:#0000bb">(.+)<\/span>/isU'                   => '[blue]$1[/red\]');
 	return preg_replace(array_keys($bbcode),array_values($bbcode),$text);
}

/* Функция смайлов */
function smiles($msg)
{
	$query = mysql_query("select * from `smiles`");
	while($row = mysql_fetch_array($query))
	{
		$code[] = $row['code'];
 		$codeRUS[] = translit($row['code']);
		$smile_url[] = '<img src="smiles/'.$row['smile_url'].'" alt="smile" />';
	}
	$msg = str_replace($codeRUS, $smile_url, $msg);
	$msg = str_replace($code, $smile_url, $msg);
	return $msg;
}

/* Функция отображения времени */
function clock($time)
{
	global $user;
	$timezone = (!$user) ? 0 : ($user['timesdvig']*3600);
	$time = $time+$timezone;
	$timep= date("j M Y в H:i:s", $time);
	$time_p[0]=date("j n Y", $time);
	$time_p[1]=date("H:i:s", $time);
	if ($time_p[0]==date("j n Y", time()))$timep='Сегодня в '.$time_p['1'];
	if ($time_p[0]==date("j n Y", time()-86400))$timep='Вчера в '.$time_p['1'];
	$months_eng = array('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	$months_rus = array('Января','Февраля','Марта','Апреля','Мая','Июня','Июля','Августа','Сентября','Октября','Ноября','Декабря');
	$timep = str_replace($months_eng,$months_rus,$timep);
	return $timep;
}

/* Функции отображения статуса */
# по ID
function status($online)
{
	$t = mysql_fetch_assoc(mysql_query("SELECT `time` FROM `users` WHERE `id` = ".$online.""));
	if($t['time']+300>time())
	{
	   echo ' <span class="user_on">[ON]</span> ';
	}
    else
	{
	   echo ' <span class="user_off">[OFF]</span> ';
	}
}
# по Логину
function statusl($online)
{
	$t = mysql_fetch_assoc(mysql_query("SELECT `time` FROM `users` WHERE `login` = '".$online."'"));
	if($t['time']+300>time())
	{
	   echo ' <span class="user_on">[ON]</span> ';
	}
    else
	{
	   echo ' <span class="user_off">[OFF]</span> ';
	}
}

 /* Функция постраничной навигации */
$page = isset($_GET['page']) ? int($_GET['page']) : 0; $i=0;
while($i<$page+$set['str'] or $i==0) $i = $i+100;
if($page+$set['str']>100) $pagefile = $page-$i+100;
else $pagefile = $page;

function pages($page, $total, $href, $num)
{
    echo '<div class="navigation">';
    if ($page) echo '<a href="'.$href.'page='.($page-$num).'"><-Назад</a> ';
    else echo '<-Назад';
    echo ' | ';
    if ($total > $page + $num)
    echo ' <a href="'.$href.'page='.($page + $num).'">Далее-></a>';
    else echo 'Далее->';
    if($total>0)
    {
    echo '<br/><br/>Страницы:';
    $minus = $page-($num*3);
    $plus = $page+($num*4);
    if($minus<$total && $minus>0) echo ' <a href="'.$href.'page=0">1</a> ... ';
    for($i=$minus; $i<$plus;)
    {
        if($i<$total && $i>=0)
        {
            $ii = floor(1+$i/$num);
            if ($page==$i) echo ' <b>['.$ii.']</b>';
            else echo ' <a href="'.$href.'page='.$i.'">'.$ii.'</a>';
        }
        $i=$i+$num;
    }
    if($plus<$total)
    {
        $whole = ceil($total/$num);
        echo ' ... <a href="'.$href.'page='.($whole*$num-$num).'">'.$whole.'</a>';
    }
}

echo '</div>';
}

/* Вывод отображения размера файла */
function size($size)
{
	if($size >= 1073741824)
	$size = round($size/1073741824*100) / 100 .' Gb';
	elseif($size >= 1048576)
	$size = round($size/1048576*100) / 100 .' Mb';
	elseif($size >= 1024)
	$size = round($size/1024*100) / 100 .' Kb';
	else $size = round($size).' b';
	return $size;
}

/* Функция только для незарегистрированных пользователей */
function unreg()
{
	global $user;
	if($user)
	{
		header("Location: ../index.php");
	}
}

/* Функция только для зарегистрированных пользователей */
function reg()
{
	global $user;
 	if(!$user)
 	{
  		header("Location: ../sign.php");
 	}
}

/* Функция для определения уровня пользователя */
function only_level($level=0)
{
    global $user;
 	if (!isset($user) or $user['level']<$level)
	{
  		header("Location: ../index.php");exit;
	}
}

/* Функция подсчета возраста */
function age($d, $m, $y)
{
	$age = date('Y') - $y;
	$_m = date('m');
	if($_m < $m || ($_m == $m && date('d') < $d))
	$age--;
	return $age;
}

/* Функция генерации пароля */
function password()
{
	$alphabet = array_merge(range('a', 'z'));
	$alphabet = array_merge($alphabet, range(0, 9));
	$string = NULL;
	for($i=0; $i<8; $i++) $string.=$alphabet[array_rand($alphabet)];
	return $string;
}

/* Функция безопасного шифрования в MD5 */
function md5_sault($text)
{
	return md5(md5('PostEngine').md5(md5($text)));
}

/* Функция отображения тем */

# Верх
function head($title)
{
	global $user, $style, $set;
	if ($user)
	{
		mysql_query("UPDATE `users` SET `where` = '".$title."' WHERE `id` = ".$user['id']."");
	}
	require BASE."style/$style/head.php";
	if($user['mail_unread'] != 0)
	{
		function sklon($number, $num='писем', $num1='письмо', $num2='письма')
    	{
    		$num100 = $number % 100;
    		$num10 = $number % 10;
    		if ($num100 >= 5 && $num100 <= 20)
        		return $number.' '.$num;
    		else if ($num10 == 0)
        		return $number.' '.$num;
    		else if ($num10 == 1)
        		return $number.' '.$num1;
    		else if ($num10 >= 2 && $num10 <= 4)
        		return $number.' '.$num2;
    		else if ($num10 >= 5 && $num10 <= 9)
        		return $number.' '.$num;
    		else
        		return $number.' '.$num2;
    }
		echo '<div class="box_2"><a href="mail.php?act=inbox"><strong><span style="color:#ff0000">У вас '.sklon($user['mail_unread']).'</span></strong></a>!</div>';
	}
}

# Низ
function foot($t)
{
 	global $set, $style;
	require BASE."style/$style/foot.php";
}

/* Функция транслитирования */
function translit($t)
{
	$a = array('&', ',', ' ', 'Я', 'Я', 'я', 'ые', 'Ё', 'ё', 'Ё', 'Ж', 'ж', 'Ж', 'З', 'з', 'Ч',
	'ч', 'Ch', 'Ш', 'ш', 'Ш', 'Э', 'э', 'Э', 'Ю', 'ю', 'Ю', 'Я', 'я', 'Я', 'А', 'а',
	'Б', 'б', 'В', 'в', 'Г', 'г', 'Д', 'д', 'Е', 'е', 'И', 'и', 'Й', 'й', 'К', 'к',
	'Л', 'л', 'М', 'м', 'Н', 'н', 'О', 'о', 'П', 'п', 'Р', 'р', 'С', 'с', 'Т', 'т',
 	'У', 'у', 'Ф', 'ф', 'Х', 'х', 'Ш', 'ш', 'ъ', 'ь', 'Ы', 'ы', 'Ц', 'ц', '');
	$b = array('and', '_', '_', 'YA', 'Ya', 'ya', 'yee', 'YO', 'yo', 'Yo', 'ZH', 'zh', 'Zh', 'Z',
    'z', 'CH', 'ch', 'Ch', 'SH', 'sh', 'Sh', 'YE', 'ye', 'Ye', 'YU', 'yu', 'Yu',
  	'JA', 'ja', 'Ja', 'A', 'a', 'B', 'b', 'V', 'v', 'G', 'g', 'D', 'd', 'E', 'e',
   	'I', 'i', 'J', 'j', 'K', 'k', 'L', 'l', 'M', 'm', 'N', 'n', 'O', 'o', 'P', 'p',
    'R', 'r', 'S', 's', 'T', 't', 'U', 'u', 'F', 'f', 'H', 'h', 'W', 'w', 'x', 'q',
 	'Y', 'y', 'C', 'c');
     return str_replace($b, $a, $t);
}

/* Функция вывода аватара */
function avatar($id)
{
	global $user, $style, $set;
	$query = mysql_fetch_assoc(mysql_query("select `avatar` from `users` where `id` = ".$id));
	return (empty($query['avatar'])) ? '<img src="style/'.$style.'/avatar.gif" alt="avatar" />' : '<img src="files/'.$query['avatar'].'" alt="avatar" />';
}
?>